# -*- coding: UTF-8 -*-
from setuphelpers import *
import requests
import json


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    arch = {"x64": "win64", "x86": "win", "all": "win"}

    # Downloading
    lang = control.locale
    # Translating locale
    if "en" in lang:
        lang = "en-US"
    if "es" in lang:
        lang = "es-ES"

    # url = requests.head('https://download.mozilla.org/?product=firefox-esr-latest-ssl&os=%s&lang=%s' % (arch[control.architecture],lang),proxies=proxies).headers['Location']
    # force next
    url = requests.head(
        "https://download.mozilla.org/?product=firefox-latest-ssl&os=osx&lang=%s" % (lang), proxies=proxies, verify=False
    ).headers["Location"]

    filename = url.rsplit("/", 1)[1].replace("%20", "_")
    version = filename.split("_")[-1].split('.dmg')[0]

    version_from_api = json.loads(wgets("https://product-details.mozilla.org/1.0/firefox_versions.json", proxies=proxies)).get("LATEST_FIREFOX_VERSION", "0")

    if Version(version_from_api) > version:
        url = url.replace(version, version_from_api)
        version = version_from_api
        filename = url.rsplit("/", 1)[1].replace("%20", "_")

    for dmg in glob.glob("*.dmg"):
        if dmg != filename:
            remove_file(dmg)

    if not isfile(filename):
        print("Downloading %s from %s" % (filename, url))
        wget(url, filename, proxies=proxies)
    else:
        print(filename + " already exist")

    # Changing version of the package
    if Version(version) > control.get_software_version():
        print("Software version updated from: %s to: %s" % (control.get_software_version(), Version(version)))
        result = True
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(Version(version))
    control.save_control_to_wapt()
